//接收端程序
 
#include <SPI.h>
#include <Mirf.h>
#include <nRF24L01.h>
#include <MirfHardwareSpiDriver.h>
 
unsigned int value;
unsigned int CH1,CH3,left,right,qi; 
void setup()
{
  Serial.begin(9600);
  Mirf.spi = &MirfHardwareSpi;
  Mirf.init();
 
  Mirf.setRADDR((byte *)"FGHIJ"); //设置自己的地址（接收端地址），使用5个字符
  Mirf.payload = sizeof(value);   
  Mirf.channel = 90;   //设置使用的信道
  Mirf.config(); 
  Serial.println("Listening...");  //开始监听接收到的数据

  pinMode(10,OUTPUT);
  pinMode(5,OUTPUT);
  pinMode(6,OUTPUT);
  pinMode(3,OUTPUT);
  pinMode(9,OUTPUT);
  digitalWrite(5,0);
  digitalWrite(6,0);
  digitalWrite(9,0);
  digitalWrite(3,0);
  digitalWrite(10,0);
}
 
void loop()
{
  if(Mirf.dataReady()) {  //当接收到程序，便从串口输出接收到的数据
    Mirf.getData((byte *) &value);

    CH3=(unsigned int)value&255; 
    CH1=(unsigned int)value>>8;
    

    if(CH1>140)
    {
       qi=CH1;
       if(CH3>135)       //左转弯
       {
         right=CH1;
         
         if(CH1<CH3)     
           left=0;
         else
           left=CH1-CH3/3.5;
       }
       else if(CH3<120)    //右转弯
       {
         if(CH1<(255-CH3))
           right=0;
         else
           right=CH1-((255-CH3)/3.5);
           
         left=CH1;
       }
       else
       {
         right=CH1;
         left=CH1;
       }
    }
    else
    { 
      left=0;
      right=0;
      qi=0;
    }
    
    analogWrite(3,left);
    analogWrite(9,right);
    analogWrite(10,qi);

    Serial.print("Got data: ");
    Serial.print(CH1);
    Serial.print(" ");
    Serial.print(CH3);
    Serial.print(" ");
    Serial.print(left);
    Serial.print(" ");
    Serial.println(right);
  }
}

